﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Windows.DataPresenter;
using System.Windows.Data;
using System.Windows;
using Infragistics.Windows.Themes;
using System.Windows.Controls;
using System.Windows.Markup;

namespace Xamdatagridexample
{
    public class MyXDG : XamDataGrid
    {       
        public object MyProperty
        {           
            get 
            {
                return (object)GetValue(MyPropertyProperty); 
            }
            set 
            { 
                SetValue(MyPropertyProperty, value);
            }
        }

        // Using a DependencyProperty as the backing store for MyProperty.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty MyPropertyProperty =
            DependencyProperty.Register("MyProperty", typeof(object), typeof(MyXDG), new UIPropertyMetadata(OnMyPropertyChanaged));

        public MyXDG() : base() { }

      /// <summary></summary>
      /// <param name="d">The d.</param>
      /// <param name="e">The e.</param>
      static void OnMyPropertyChanaged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            int index = ((e.NewValue as ListBoxItem).Parent as ComboBox).SelectedIndex;
            switch (index)
            {
                case 0:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("Aero");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameAero;
                    break;
                }
            case 1:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("Generic");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameGeneric;
                    break;
                }
            case 2:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("LunaNormal");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameLunaNormal;
                    break;
                }
            case 3:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("LunaOlive");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameLunaOlive;
                    break;
                }
            case 4:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("LunaSilver");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameLunaSilver;
                    break;
                }
            case 5:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("Office2k7Black");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameOffice2k7Black;
                    break;
                }
            case 6:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("Office2k7Blue");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameOffice2k7Blue;
                    break;
                }
            case 7:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("Office2k7Silver");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameOffice2k7Silver;
                    break;
                }
            case 8:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("Onyx");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameOnyx;
                    break;
                }
            case 9:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("PrintBasic");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNamePrintBasic;
                    break;
                }
            case 10:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("Royale");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameRoyale;
                    break;
                }

            case 11:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("RoyaleStrong");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameRoyaleStrong;
                    break;
                }
            case 12:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetExternalDRCAStyle("Fall");
                    ResourceSet fall = new Infragistics.Windows.Themes.Fall.DataPresenter();
                    ThemeManager.CurrentTheme = fall.Theme;
                    break;
                }
            case 13:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetExternalDRCAStyle("ForestGreen");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameForestGreen;
                    break;
                }
            case 14:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetExternalDRCAStyle("Leaf");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameLeaf;
                    break;
                }
            case 15:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetExternalDRCAStyle("Lipstick");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameLipstick;
                    break;
                }
            case 16:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetExternalDRCAStyle("Water");
                    ResourceSet water = new Infragistics.Windows.Themes.Water.DataPresenter();
                    ThemeManager.CurrentTheme = water.Theme;
                    break;
                }
            case 17:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetExternalDRCAStyle("Wind");
                    ResourceSet wind = new Infragistics.Windows.Themes.Wind.DataPresenter();
                    ThemeManager.CurrentTheme = wind.Theme;
                    break;
                }
            case 18:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("IGTheme");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameIGTheme;
                    break;
                }

            default:
                {
                    (d as MyXDG).FieldLayoutSettings.DataRecordCellAreaStyle = SetDRCAStyle("Generic");
                    ThemeManager.CurrentTheme = ThemeManager.ThemeNameGeneric;
                    break;
                }
        }            

        }

        public static Style SetExternalDRCAStyle(string ThemeName)
        {
            string stylestring = @"<Style  xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation'  " +
                                         " xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml' " +
                                         " xmlns:igDP='http://infragistics.com/DataPresenter' " +
                                         "xmlns:igTheme" + ThemeName + "='http://infragistics.com/Themes/" + ThemeName + "'" +
                                         " BasedOn='{x:Static igTheme" + ThemeName + ":DataPresenter.DataRecordCellArea}' " +
                                         " TargetType='{x:Type igDP:DataRecordCellArea}' >" +
                                       "<Setter Property='BorderBrush' Value='#EEEEEEEE' /> " +
                                       "<Setter Property='BorderThickness' Value='0,0,0,2' /> " +
                                       "<Setter Property='Height' Value='30' /> " +
                                   "</Style>   ";

            return XamlReader.Parse(stylestring) as Style;
        }


        public static Style SetDRCAStyle(string ThemeName)
        {
            string stylestring = @"<Style  xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation'  " +
                                         " xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml' " +
                                         " xmlns:igDP='http://infragistics.com/DataPresenter' " +
                                         " BasedOn='{x:Static igThemes:DataPresenter" + ThemeName + ".DataRecordCellArea}' " +
                                         " TargetType='{x:Type igDP:DataRecordCellArea}' " +
                                         " xmlns:igThemes='http://infragistics.com/Themes'>" +
                                       "<Setter Property='BorderBrush' Value='#EEEEEEEE' /> " +
                                       "<Setter Property='BorderThickness' Value='0,0,0,2' /> " +
                                       "<Setter Property='Height' Value='30' /> " +
                                   "</Style>   ";

            return XamlReader.Parse(stylestring) as Style;
        }    
    }
}
